// Code generated by tablegen. DO NOT EDIT.
package tables

func (t AllTables) UserCoinTransactions() UserCoinTransactions { return UserCoinTransactions(t) }

type UserCoinTransactions struct{ alias string }

func (t UserCoinTransactions) TableAlias() string { return t.alias }
func (t UserCoinTransactions) name() string       { return "UserCoinTransactions" }
func (t UserCoinTransactions) TableName() string  { return tableName(t.name(), "", t.alias) }
func (t UserCoinTransactions) AllColumnNames() []string {
	c := t.Columns()
	return []string{
		c.ID(),
		c.Amount(),
		c.UserID(),
		c.CreatedAt(),
	}
}

func (t UserCoinTransactions) Columns() UserCoinTransactionsCols {
	return UserCoinTransactionsCols{tableAlias: t.alias}
}

type UserCoinTransactionsCols struct{ tableAlias string }

func (c UserCoinTransactionsCols) ID() string        { return colName(c.tableAlias, "ID") }        // STRING(36)
func (c UserCoinTransactionsCols) Amount() string    { return colName(c.tableAlias, "Amount") }    // INT64
func (c UserCoinTransactionsCols) UserID() string    { return colName(c.tableAlias, "UserID") }    // STRING(36)
func (c UserCoinTransactionsCols) CreatedAt() string { return colName(c.tableAlias, "CreatedAt") } // TIMESTAMP OPTIONS (allow_commit_timestamp = true)

func (t UserCoinTransactions) Indexes() UserCoinTransactionsIndexes {
	return UserCoinTransactionsIndexes{table: t}
}

type UserCoinTransactionsIndexes struct{ table UserCoinTransactions }

func (i UserCoinTransactionsIndexes) ByUserIDCreatedAt() Index {
	c := i.table.Columns()
	return Index{
		tableAlias: i.table.alias,
		tableName:  i.table.name(),
		indexName:  "UserCoinTransactions_UserID",
		columns: []string{
			c.ID(),
			c.Amount(),
			c.UserID(),
			c.CreatedAt(),
		},
	}
}
